function apply_to_color(colorinput_name,input_name,enhanced_name, colorenhanced_name)
% Apply the contrast enhancement (in gray levels) to the colored image.
% (channel per channel)

GRAY_input    = double(imread(input_name));
GRAY_enhanced = double(imread(enhanced_name));
COLOR_input   = double(imread(colorinput_name));

gain_map = zeros(size(GRAY_input));
nonnul_i = find(GRAY_input ~= 0);
gain_map(nonnul_i) = GRAY_enhanced(nonnul_i)./GRAY_input(nonnul_i);

COLOR_enhanced = zeros(size(COLOR_input));
COLOR_enhanced(:,:,1) = COLOR_input(:,:,1).*gain_map;
COLOR_enhanced(:,:,2) = COLOR_input(:,:,2).*gain_map;
COLOR_enhanced(:,:,3) = COLOR_input(:,:,3).*gain_map;

imwrite(uint8(COLOR_enhanced), colorenhanced_name);

% % % Gestion de la saturation...
% % max_layer = max(COLOR_enhanced,[],3);
% % R_layer = COLOR_enhanced(:,:,1);
% % G_layer = COLOR_enhanced(:,:,2);
% % B_layer = COLOR_enhanced(:,:,3);
% % 
% % saturated_pix = find(max_layer > 255);
% % 
% % R_layer(saturated_pix) = R_layer(saturated_pix)./max_layer(saturated_pix).*255;
% % G_layer(saturated_pix) = G_layer(saturated_pix)./max_layer(saturated_pix).*255;
% % B_layer(saturated_pix) = B_layer(saturated_pix)./max_layer(saturated_pix).*255;
% % 
% % COLOR_enhanced_NOSAT = cat(3,R_layer,G_layer,B_layer);

% % imwrite(uint8(COLOR_enhanced_NOSAT), colorenhanced_name);

end